package org.processmining.security.plugins.interDataProcessPolicy;

public class CRUDEntry implements Comparable<CRUDEntry>{
	private String data;
	private String operation;
	
	public CRUDEntry(String data, String operation) {
		this.data = data;
		this.operation = operation; 
	}
	public String getData() {
		return data;
	}
	public String getOperation() {
		return operation;
	}
	public boolean isPermitted(String data, String operation){
		if(this.data.equalsIgnoreCase(data) && this.operation.equalsIgnoreCase(operation))
			return true;
		return false;
	}

	public int compareTo(CRUDEntry crudEntry) {
		if(data.equals(crudEntry.getData()) && operation.equals(crudEntry.getOperation()))
			return 0;
		return -1;
	}
	public String toString() {
		return data + ":" + operation;
	}
	public boolean isOptional(){
		if('a' <= operation.charAt(0) && operation.charAt(0) <= 'z') 
			return true;
		return false;
	}
	public boolean equals(Object obj) {
		return compareTo((CRUDEntry) obj) == 0;
	}
}
