package org.processmining.security.plugins.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.HashMap;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.table.DefaultTableCellRenderer;

import org.processmining.framework.util.ui.widgets.ProMTable;
import org.processmining.security.plugins.replayer.CompositeMoveType;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class CostFunctionPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ProMTable costFunctionTable;
	public CostFunctionPanel(){
		setLayout(new BorderLayout());
		// label
		SlickerFactory slickerFactoryInstance = SlickerFactory.instance();
		costFunctionTable = new ProMTable(new CostFunctionTableModel());
		DefaultTableCellRenderer centerRenderer = new DefaultTableCellRenderer();
		centerRenderer.setHorizontalAlignment( JLabel.CENTER );
		centerRenderer.setVerticalAlignment( JLabel.CENTER );
		costFunctionTable.getTable().setDefaultRenderer(Object.class, centerRenderer);
		
		costFunctionTable.getTable().setRowHeight(20);
		add(slickerFactoryInstance
				.createLabel("Double click costs on table to change their values. Use only non-negative doubles"),
				BorderLayout.NORTH);
		costFunctionTable.setPreferredSize(new Dimension(800, 200));
		costFunctionTable.setMinimumSize(new Dimension(800, 200));
		add(costFunctionTable, BorderLayout.CENTER);
	}
	public HashMap<CompositeMoveType, Double> getCosts(){
		HashMap<CompositeMoveType, Double> costs = new HashMap<CompositeMoveType, Double>();
		for(CompositeMoveType type: CompositeMoveType.values()){
			int index[] = getIndex(type); 
			costs.put(type, Double.valueOf(costFunctionTable.getValueAt(index[0], index[1]).toString()));
		}
		return costs;
	}
	private int[] getIndex(CompositeMoveType type){
		int index[] = {-1,-1};
		switch(type){
			case SYNC_PROC_SYNC_DATA:
				index[0] = 0;
				index[1] = 1;
				break;
			case MMODEL_PROC_SYNC_DATA:
				index[0] = 0;
				index[1] = 2;
				break;
			case MLOG_PROC_SYNC_DATA:
				index[0] = 0;
				index[1] = 3;
				break;
			case SYNC_PROC_MMODEL_DATA:
				index[0] = 1;
				index[1] = 1;
				break;
			case MMODEL_PROC_MMODEL_DATA:
				index[0] = 1;
				index[1] = 2;
				break;
			case MLOG_PROC_MMODEL_DATA:
				index[0] = 1;
				index[1] = 3;
				break;
			case SYNC_PROC_MLOG_DATA:
				index[0] = 2;
				index[1] = 1;
				break;
			case MMODEL_PROC_MLOG_DATA:
				index[0] = 2;
				index[1] = 2;
				break;
			case MLOG_PROC_MLOG_DATA:
				index[0] = 2;
				index[1] = 3;
				break;
			case NO_CONTEXT:
				index[0] = 2;
				index[1] = 4;
				break;
			case SYNC_PROC_NO_OP:
				index[0] = 3;
				index[1] = 1;
				break;
			case MMODEL_PROC_NO_OP:
				index[0] = 3;
				index[1] = 2;
				break;
			case MLOG_PROC_NO_OP:
				index[0] = 3;
				index[1] = 3;
				break;
		}
		return index;
	}
}
